<?php

namespace App\Repository;

use App\Entity\Group;
use App\Entity\Provider;
use App\Entity\Student;
use Doctrine\DBAL\Driver\AbstractMySQLDriver;
use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\NonUniqueResultException;
use Doctrine\ORM\NoResultException;
use Symfony\Component\Uid\Uuid;

/**
 * StudentRepository.
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class StudentRepository extends EntityRepository
{
    protected $checkedIsStudentUsername = [];

//    /**
//     * @deprecated
//     */
//    public function addStudent($provider, $element)
//    {
//        $em = $this->getEntityManager();
    //
//        $student = $em->getRepository('App\Entity\Student')->find($element['id']);
//        if (!$student) {
//            $student = new Student($element['id']);
//            $student->setId($element['id']);
//            $em->persist($student);
//            $em->flush();
//        }
//        if (!$student->isSame($element)) {
//            $student->setFirstname($element['firstname']);
//            $student->setLastname($element['lastname']);
//            if(!$provider->getGoogleAppAutoEmail()) {
//                $student->setEmail($element['email']);
//            }
//            if ((array_key_exists('password', $element)) and ($provider->getForceImportedPassword())) {
//                $student->setStartingPassword($element['password']);
//            }
//            $student->setProvider($provider);
//            $em->flush();
//        }
    //
//        return $student;
//    }

    public function createWithImportData($importedData, Provider $provider, $idOnProvider)
    {
        if (!$importedData instanceof \App\ImporterFilter\ImportedEntity\Student) {
            return null;
        }

        $existent = $this->findOneBy(['fiscalCode' => $importedData->getFiscalCode()]);
        if ($existent instanceof Student) {
            throw new \Error("Student with fiscal code {$importedData->getFiscalCode()} already exists");
        }

        $student = new Student($importedData->getFiscalCode());
        $student->setFirstname($importedData->getFirstName());
        $student->setLastname($importedData->getLastName());

        if (null !== $importedData->getEmail()) {
            $student->setEmail($importedData->getEmail());
        }

        if (null !== $importedData->getUsername()) {
            $student->setUsername($importedData->getUsername());
        }
        if (null !== $importedData->getPassword() && null === $student->getStartingPassword()) {
            $student->setStartingPassword($importedData->getPassword());
        }

        if ($importedData->getGroup() instanceof Group) {
            $student->addMemberOf($importedData->getGroup());
        }

        $student->setProvider($provider);
        $student->setIdOnProvider($idOnProvider);
        $this->getEntityManager()->persist($student);
        $this->getEntityManager()->flush();

        return $student;
    }

    public function updateWithImportData(Student $student, $newData, Provider $provider)
    {
        if (!$newData instanceof \App\ImporterFilter\ImportedEntity\Student) {
            return $student;
        }

        $student->setFiscalCode($newData->getFiscalCode());
        $student->setFirstname($newData->getFirstName());
        $student->setLastname($newData->getLastName());

        if (null !== $newData->getEmail()) {
            $student->setEmail($newData->getEmail());
        }

        if (null !== $newData->getUsername()) {
            $student->setUsername($newData->getUsername());
        }

        if (null !== $newData->getPassword() && null === $student->getStartingPassword()) {
            $student->setStartingPassword($newData->getPassword());
        }

        if ($newData->getGroup() instanceof Group) {
            $found = false;
            foreach ($student->getNotManuallyManagedGroups() as $group) {
                if ($group->getId() != $newData->getGroup()->getId()) {
                    if ($group->getProvider()->getId() === $provider->getId()) {
                        $student->removeMemberOf($group);
                    }
                } else {
                    $found = true;
                }
            }

            if (!$found) {
                $student->addMemberOf($newData->getGroup());
            }
        } else {
            foreach ($student->getNotManuallyManagedGroups() as $group) {
                if ($group->getProvider()->getId() === $provider->getId()) {
                    $student->removeMemberOf($group);
                }
            }
        }

		$student->setTrashedDate(null); //untrash the student

        $this->getEntityManager()->flush();

        return $student;
    }

    public function updateMembershipWithImportData(Student $student, $newData, Provider $provider)
    {
        if (!$newData instanceof \App\ImporterFilter\ImportedEntity\Student) {
            return $student;
        }

        if ($newData->getGroup() instanceof Group) {
            $found = false;
            foreach ($student->getNotManuallyManagedGroups() as $group) {
                if ($group->getId() != $newData->getGroup()->getId()) {
                    if ($group->getProvider()->getId() === $provider->getId()) {
                        $student->removeMemberOf($group);
                    }
                } else {
                    $found = true;
                }
            }

            if (!$found) {
                $student->addMemberOf($newData->getGroup());
            }
        } else {
            foreach ($student->getNotManuallyManagedGroups() as $group) {
                if ($group->getProvider()->getId() === $provider->getId()) {
                    $student->removeMemberOf($group);
                }
            }
        }

        $this->getEntityManager()->flush();

        return $student;
    }

    public function getAllStudentsUsername()
    {
        $em = $this->getEntityManager();
        $students = $this->findAll();
        $studentsUsername = [];
        foreach ($students as $student) {
            if ('' != $student->getUsername()) {
                $studentsUsername[] = strtolower($student->getUsername());
            }
        }

        return $studentsUsername;
    }

    public function userIsStudent($username)
    {
        if (!isset($checkedIsStudentUsername[$username])) {
            try {
                $count = $this->createQueryBuilder('s')
                    ->select('COUNT(s)')
                    ->where('s.username = :username')
                    ->setParameter('username', $username)
                    ->getQuery()
                    ->getSingleScalarResult();
            } catch (NoResultException $e) {
                $count = 0;
            } catch (NonUniqueResultException $e) {
                $count = 0;
            }

            $checkedIsStudentUsername[$username] = $count > 0;
        }

        return $checkedIsStudentUsername[$username];
    }

    public function getUsernamesNotInLdapUser()
    {
        $em = $this->getEntityManager();

        $query = $em->createQuery('SELECT s.username FROM App\Entity\Student s LEFT JOIN App\Entity\LdapUser l WITH s.username = l.username WHERE l.username IS NULL AND NOT s.username IS NULL');
        $query->execute();
        $results = $query->getResult();

        $usernames = [];
        foreach ($results as $result) {
            $usernames[] = strtolower($result['username']);
        }

        return $usernames;
    }

	public function getStudentsWithoutManagedDeviceQuery($filters=[], $providers=null, $noTrashed=true) {
		$queryBuilder = $this->createQueryBuilder("s")
		                     ->leftJoin("s.mdmDevices", 'd')
		                     ->leftJoin('s.memberOf', 'g')
		                     ->where('g.manageManually = false OR g.id IS NULL')
		                     ->addGroupBy("s.id")
		                     ->addGroupBy('g.name')
		                     ->having("COUNT(d.id) = 0")
		                     ->addOrderBy('s.provider', 'ASC')
		                     ->addOrderBy('g.name', 'ASC')
		                     ->addOrderBy('s.lastname', 'ASC');

		if(isset($filters['groupId']) && $filters['groupId'] != "") {
			if($this->getEntityManager()->getConnection()->getDriver() instanceof AbstractMySQLDriver) {
				$queryBuilder->andWhere( "g.id = :gid" )->setParameter( "gid", (new Uuid($filters['groupId']))->toBinary() );
			} else {
				$queryBuilder->andWhere("g.id = :gid")->setParameter("gid", $filters['groupId']);
			}
		}

		if(isset($filters['providerId']) && $filters['providerId'] != "") {
			if($this->getEntityManager()->getConnection()->getDriver() instanceof AbstractMySQLDriver) {
				$queryBuilder->andWhere( "s.provider = :pid" )->setParameter( "pid", (new Uuid($filters['providerId']))->toBinary() );
			} else {
				$queryBuilder->andWhere( "s.provider = :pid" )->setParameter( "pid", $filters['providerId'] );
			}
		}

		if(!empty($providers)) {
			$queryBuilder->andWhere($queryBuilder->expr()->in("s.provider", ':pids'));

			if($this->getEntityManager()->getConnection()->getDriver() instanceof AbstractMySQLDriver) {
				$queryBuilder->setParameter( 'pids', array_map( fn ( $provider ) => $provider->getId()->toBinary(), $providers ) );
			} else {
				$queryBuilder->setParameter( 'pids', array_map( fn ( $provider ) => $provider->getId(), $providers ) );
			}
		}

		if($noTrashed) {
			$queryBuilder->andWhere("s.trashedDate IS NULL");
		}

		return $queryBuilder;
	}

	public function getTrashedQuery($providerId=null)
	{
		$queryBuilder = $this->createQueryBuilder('s')->where('NOT s.trashedDate IS NULL');
		if($providerId !== null) {
			$queryBuilder->andWhere("s.provider = :pids");
			if($this->getEntityManager()->getConnection()->getDriver() instanceof AbstractMySQLDriver) {
				$queryBuilder->setParameter('pids', $providerId->toBinary());
			} else {
				$queryBuilder->setParameter('pids', $providerId);
			}
		}
		return $queryBuilder->getQuery();
	}

	public function getNotTrashedQuery($providerId=null)
	{
		$queryBuilder = $this->createQueryBuilder('s')->where('s.trashedDate IS NULL');
		if($providerId !== null) {
			$queryBuilder->andWhere("s.provider = :pids");
			if($this->getEntityManager()->getConnection()->getDriver() instanceof AbstractMySQLDriver) {
				$queryBuilder->setParameter('pids', $providerId->toBinary());
			} else {
				$queryBuilder->setParameter('pids', $providerId);
			}
		}

		return $queryBuilder->getQuery();
	}

    public function getTrashed()
    {
        return $this->createQueryBuilder('s')
            ->andWhere('NOT s.trashedDate IS NULL')
            ->orderBy('s.lastname', 'ASC')
            ->getQuery()
            ->execute();
    }
}
